package eu.eudat.file.transformer.enums;

import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Map;

public enum DmpBlueprintSystemFieldType implements DatabaseEnum<Short> {

    Text((short)0),
    HtmlText((short)1),
    Researchers((short)2),
    Organizations((short)3),
    Language((short)4),
    Contact((short)5),
    Funder((short)6),
    Grant((short)7),
    Project((short)8),
    License((short)9),
    AccessRights((short)10);
    private final Short value;

    DmpBlueprintSystemFieldType(Short value) {
        this.value = value;
    }

    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpBlueprintSystemFieldType> map = EnumUtils.getEnumValueMap(DmpBlueprintSystemFieldType.class);

    public static DmpBlueprintSystemFieldType of(Short i) {
        return map.get(i);
    }
}