package eu.eudat.file.transformer.enums;

import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Map;

public enum DmpUserRole implements DatabaseEnum<Short> {

    Owner((short) 0), User((short) 1);

    private final Short value;

    DmpUserRole(Short value) {
        this.value = value;
    }

    @Override
    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpUserRole> map = EnumUtils.getEnumValueMap(DmpUserRole.class);

    public static DmpUserRole of(Short i) {
        return map.get(i);
    }

}
