package eu.eudat.file.transformer.enums;

import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Map;

public enum DmpVersionStatus implements DatabaseEnum<Short> {

    Current((short) 0), Previous ((short) 1);

    private final Short value;

    DmpVersionStatus(Short value) {
        this.value = value;
    }

    @Override
    @JsonValue
    public Short getValue() {
        return value;
    }

    private static final Map<Short, DmpVersionStatus> map = EnumUtils.getEnumValueMap(DmpVersionStatus.class);

    public static DmpVersionStatus of(Short i) {
        return map.get(i);
    }
}
