package eu.eudat.file.transformer.enums;

import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Map;

public enum FieldType implements DatabaseEnum<String> {
	EXTERNAL_SELECT(Names.ExternalSelect),
	SELECT(Names.Select),
	BOOLEAN_DECISION(Names.BooleanDecision),
	RADIO_BOX(Names.RadioBox),
	INTERNAL_DMP_ENTRIES_RESEARCHERS(Names.InternalDmpResearchers),
	INTERNAL_DMP_ENTRIES_DMPS(Names.InternalDmpDmps),
	INTERNAL_DMP_ENTRIES_DATASETS(Names.InternalDmpDatasets),
	CHECK_BOX(Names.CheckBox),
	FREE_TEXT(Names.FreeText),
	TEXT_AREA(Names.TextArea),
	RICH_TEXT_AREA(Names.RichTextarea),
	UPLOAD(Names.Upload),
	DATE_PICKER(Names.DatePicker),
	EXTERNAL_DATASETS(Names.ExternalDatasets),
	DATA_REPOSITORIES(Names.DataRepositories),
	JOURNAL_REPOSITORIES(Names.JournalRepositories),
	PUB_REPOSITORIES(Names.PubRepositories),
	LICENSES(Names.Licenses),
	TAXONOMIES(Names.Taxonomies),
	PUBLICATIONS(Names.Publications),
	REGISTRIES(Names.Registries),
	SERVICES(Names.Services),
	TAGS(Names.Tags),
	RESEARCHERS(Names.Researchers),
	ORGANIZATIONS(Names.Organizations),
	DATASET_IDENTIFIER(Names.DatasetIdentifier),
	CURRENCY(Names.Currency),
	VALIDATION(Names.Validation);
	private final String value;
	
	public static class Names {
		public static final String ExternalSelect = "externalSelect";
		public static final String Select = "select";
		public static final String BooleanDecision = "booleanDecision";
		public static final String RadioBox = "radiobox";
		public static final String InternalDmpResearchers = "internalDmpResearchers";
		public static final String InternalDmpDmps = "internalDmpDmps";
		public static final String InternalDmpDatasets = "internalDmpDatasets";
		public static final String CheckBox = "checkBox";
		public static final String FreeText = "freetext";
		public static final String TextArea = "textarea";
		public static final String RichTextarea = "richTextarea";
		public static final String Upload = "upload";
		public static final String DatePicker = "datePicker";
		public static final String ExternalDatasets = "externalDatasets";
		public static final String DataRepositories = "dataRepositories";
		public static final String JournalRepositories = "journalRepositories";
		public static final String PubRepositories = "pubRepositories";
		public static final String Licenses = "licenses";
		public static final String Taxonomies = "taxonomies";
		public static final String Publications = "publications";
		public static final String Registries = "registries";
		public static final String Services = "services";
		public static final String Tags = "tags";
		public static final String Researchers = "researchers";
		public static final String Organizations = "organizations";
		public static final String DatasetIdentifier = "datasetIdentifier";
		public static final String Currency = "currency";
		public static final String Validation = "validation";
	}

	FieldType(String value) {
		this.value = value;
	}

	@JsonValue
	public String getValue() {
		return value;
	}

	private static final Map<String, FieldType> map = EnumUtils.getEnumValueMap(FieldType.class);

	public static FieldType of(String i) {
		return map.get(i);
	}
}
