package eu.eudat.file.transformer.enums;

import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Map;

public enum ReferenceType implements DatabaseEnum<Short> {
	Taxonomies((short) 0),
	Licenses((short) 1),
	Publications((short) 2),
	Journals((short) 3),
	PubRepositories((short) 4),
	DataRepositories((short) 5),
	Registries((short) 6),
	Services((short) 7),
	Project((short) 8),
	Funder((short) 9),
	Datasets((short) 10),
	Organizations((short) 11),
	Grants((short) 12),
	Researcher((short) 13);
	private final Short value;

	ReferenceType(Short value) {
		this.value = value;
	}

	@JsonValue
	public Short getValue() {
		return value;
	}

	private static final Map<Short, ReferenceType> map = EnumUtils.getEnumValueMap(ReferenceType.class);

	public static ReferenceType of(Short i) {
		return map.get(i);
	}
}
