package eu.eudat.file.transformer.models.description;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import eu.eudat.file.transformer.enums.DescriptionStatus;
import eu.eudat.file.transformer.models.descriptiontemplate.DescriptionTemplateFileTransformerModel;
import eu.eudat.file.transformer.models.dmp.DmpFileTransformerModel;
import eu.eudat.file.transformer.models.user.UserFileTransformerModel;

import java.time.Instant;
import java.util.List;
import java.util.UUID;
@JsonIgnoreProperties(ignoreUnknown = true)
public class DescriptionFileTransformerModel {

    private UUID id;
    private String label;
    private String description;
    private DescriptionStatus status;
    private UserFileTransformerModel createdBy;
    private Instant createdAt;
    private Instant updatedAt;
    private Instant finalizedAt;
    private List<DescriptionReferenceFileTransformerModel> descriptionReferenceFileTransformerModels;
    private List<DescriptionTagFileTransformerModel> descriptionTagFileTransformerModels;
    private UUID sectionId;
    private DescriptionTemplateFileTransformerModel descriptionTemplate;
    private DmpFileTransformerModel dmp;

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public DescriptionStatus getStatus() {
        return status;
    }

    public void setStatus(DescriptionStatus status) {
        this.status = status;
    }

    public UserFileTransformerModel getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(UserFileTransformerModel createdBy) {
        this.createdBy = createdBy;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Instant getFinalizedAt() {
        return finalizedAt;
    }

    public void setFinalizedAt(Instant finalizedAt) {
        this.finalizedAt = finalizedAt;
    }

    public List<DescriptionReferenceFileTransformerModel> getDescriptionReferenceFileTransformerModels() {
        return descriptionReferenceFileTransformerModels;
    }

    public void setDescriptionReferenceFileTransformerModels(List<DescriptionReferenceFileTransformerModel> descriptionReferenceFileTransformerModels) {
        this.descriptionReferenceFileTransformerModels = descriptionReferenceFileTransformerModels;
    }

    public List<DescriptionTagFileTransformerModel> getDescriptionTagFileTransformerModels() {
        return descriptionTagFileTransformerModels;
    }

    public void setDescriptionTagFileTransformerModels(List<DescriptionTagFileTransformerModel> descriptionTagFileTransformerModels) {
        this.descriptionTagFileTransformerModels = descriptionTagFileTransformerModels;
    }

    public UUID getSectionId() {
        return sectionId;
    }

    public void setSectionId(UUID sectionId) {
        this.sectionId = sectionId;
    }

    public DescriptionTemplateFileTransformerModel getDescriptionTemplate() {
        return descriptionTemplate;
    }

    public void setDescriptionTemplate(DescriptionTemplateFileTransformerModel descriptionTemplate) {
        this.descriptionTemplate = descriptionTemplate;
    }

    public DmpFileTransformerModel getDmp() {
        return dmp;
    }

    public void setDmp(DmpFileTransformerModel dmp) {
        this.dmp = dmp;
    }
}
