package eu.eudat.file.transformer.models.dmp;

import eu.eudat.file.transformer.enums.DmpAccessType;
import eu.eudat.file.transformer.enums.DmpStatus;
import eu.eudat.file.transformer.enums.DmpVersionStatus;
import eu.eudat.file.transformer.models.dmpblueprint.DmpBlueprintFileTransformerModel;
import eu.eudat.file.transformer.models.entitydoi.EntityDoiFileTransformerModel;
import eu.eudat.file.transformer.models.description.DescriptionFileTransformerModel;
import eu.eudat.file.transformer.models.user.UserFileTransformerModel;

import java.time.Instant;
import java.util.List;
import java.util.UUID;

public class DmpFileTransformerModel {

    private UUID id;
    private String variant;
    private String label;
    private String description;
    private Short version;
    private DmpStatus status;
    private DmpVersionStatus versionStatus;
    private String properties;
    private Instant createdAt;
    private Instant updatedAt;
    private Instant finalizedAt;
    private Instant publishedAt;
    private UserFileTransformerModel creator;
    private DmpAccessType accessType;
    private DmpBlueprintFileTransformerModel blueprint;
    private String language;
    private Instant publicAfter;
    private List<DmpReferenceFileTransformerModel> dmpReferences;
    private List<DmpUserFileTransformerModel> dmpUsers;
    private List<DescriptionFileTransformerModel> descriptions;
    private List<EntityDoiFileTransformerModel> entityDois;

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getVariant() {
        return variant;
    }

    public void setVariant(String variant) {
        this.variant = variant;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Short getVersion() {
        return version;
    }

    public void setVersion(Short version) {
        this.version = version;
    }

    public DmpStatus getStatus() {
        return status;
    }

    public void setStatus(DmpStatus status) {
        this.status = status;
    }

    public DmpVersionStatus getVersionStatus() {
        return versionStatus;
    }

    public void setVersionStatus(DmpVersionStatus versionStatus) {
        this.versionStatus = versionStatus;
    }

    public String getProperties() {
        return properties;
    }

    public void setProperties(String properties) {
        this.properties = properties;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Instant getFinalizedAt() {
        return finalizedAt;
    }

    public void setFinalizedAt(Instant finalizedAt) {
        this.finalizedAt = finalizedAt;
    }

    public Instant getPublishedAt() {
        return publishedAt;
    }

    public void setPublishedAt(Instant publishedAt) {
        this.publishedAt = publishedAt;
    }

    public UserFileTransformerModel getCreator() {
        return creator;
    }

    public void setCreator(UserFileTransformerModel creator) {
        this.creator = creator;
    }

    public DmpAccessType getAccessType() {
        return accessType;
    }

    public void setAccessType(DmpAccessType accessType) {
        this.accessType = accessType;
    }

    public DmpBlueprintFileTransformerModel getBlueprint() {
        return blueprint;
    }

    public void setBlueprint(DmpBlueprintFileTransformerModel blueprint) {
        this.blueprint = blueprint;
    }

    public String getLanguage() {
        return language;
    }

    public void setLanguage(String language) {
        this.language = language;
    }

    public Instant getPublicAfter() {
        return publicAfter;
    }

    public void setPublicAfter(Instant publicAfter) {
        this.publicAfter = publicAfter;
    }

    public List<DmpReferenceFileTransformerModel> getDmpReferences() {
        return dmpReferences;
    }

    public void setDmpReferences(List<DmpReferenceFileTransformerModel> dmpReferences) {
        this.dmpReferences = dmpReferences;
    }

    public List<DmpUserFileTransformerModel> getDmpUsers() {
        return dmpUsers;
    }

    public void setDmpUsers(List<DmpUserFileTransformerModel> dmpUsers) {
        this.dmpUsers = dmpUsers;
    }

    public List<DescriptionFileTransformerModel> getDescriptions() {
        return descriptions;
    }

    public void setDescriptions(List<DescriptionFileTransformerModel> descriptions) {
        this.descriptions = descriptions;
    }

    public List<EntityDoiFileTransformerModel> getEntityDois() {
        return entityDois;
    }

    public void setEntityDois(List<EntityDoiFileTransformerModel> entityDois) {
        this.entityDois = entityDois;
    }
}
